## cub 1.9.8

=== debian/changelog ===
cub (1.9.8-1) unstable; urgency=medium

  * Initial release.
  * CUB is now released independently from thrust.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 29 Jul 2020 02:25:02 +0200

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# the cmake build system for examples and tests assumes CUDA availability
override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_auto_clean:

override_dh_installchangelogs:
	dh_installchangelogs CHANGE_LOG.TXT

override_dh_installexamples:
	dh_installexamples -X.gitignore

## cub 1.11.0

=== CMakeLists.txt ===
# Will be increased to 3.18 when C++17 is enabled:
cmake_minimum_required(VERSION 3.15)

# Remove this when we use the new CUDA_ARCHITECTURES properties.
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.18)
  cmake_policy(SET CMP0104 OLD)
endif()

# CXX is only needed for AppendOptionIfAvailable.
project(CUB)

# Determine whether CUB is the top-level project or included into
# another project via add_subdirectory().
if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}")
  set(CUB_TOPLEVEL_PROJECT ON)
else()
  set(CUB_TOPLEVEL_PROJECT OFF)
endif()

# This must be done before any languages are enabled:
if (CUB_TOPLEVEL_PROJECT)
  include(cmake/CubCompilerHacks.cmake)
endif()

# This must appear after our Compiler Hacks or else CMake will delete the cache
# and reconfigure from scratch.
# This must also appear before the installation rules, as it is required by the
# GNUInstallDirs CMake module.
enable_language(CXX)

# Thrust has its own copy of CUB install rules to handle packaging usecases
# where we want to install CUB headers but aren't actually building anything.
# In these cases the add_subdirectory(dependencies/cub) line in Thrust won't get
# called so we can't rely on CUB providing its own rules.
if (NOT CUB_IN_THRUST)
  option(CUB_ENABLE_INSTALL_RULES "Enable installation of CUB" ${CUB_TOPLEVEL_PROJECT})
  if (CUB_ENABLE_INSTALL_RULES)
    include(cmake/CubInstallRules.cmake)
  endif()
endif()

# Support adding CUB to a parent project via add_subdirectory.
# See examples/cmake/add_subdir/CMakeLists.txt for details.
if (NOT CUB_TOPLEVEL_PROJECT AND NOT CUB_IN_THRUST)
  include(cmake/CubAddSubdir.cmake)
  return()
endif()

option(CUB_ENABLE_HEADER_TESTING "Test that all public headers compile." ON)
option(CUB_ENABLE_TESTING "Build CUB testing suite." ON)
option(CUB_ENABLE_EXAMPLES "Build CUB examples." ON)

# Check if we're actually building anything before continuing. If not, no need
# to search for deps, etc. This is a common approach for packagers that just
# need the install rules. See GH issue NVIDIA/thrust#1211.
if (NOT (CUB_ENABLE_HEADER_TESTING OR
         CUB_ENABLE_TESTING OR
         CUB_ENABLE_EXAMPLES))
  return()
endif()

include(cmake/AppendOptionIfAvailable.cmake)
include(cmake/CubBuildCompilerTargets.cmake)
include(cmake/CubBuildTargetList.cmake)
include(cmake/CubCudaConfig.cmake)

if ("" STREQUAL "${CMAKE_BUILD_TYPE}")
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build." FORCE)

  set_property(
    CACHE CMAKE_BUILD_TYPE
    PROPERTY STRINGS Debug Release RelWithDebInfo MinSizeRel
  )
endif ()

set(CMAKE_CXX_EXTENSIONS OFF)

# Where to put build outputs. Use CMAKE_BINARY_DIR so they'll show up alongside
# Thrust targets when building as part of Thrust.
set(CUB_LIBRARY_OUTPUT_DIR "${CMAKE_BINARY_DIR}/lib")
set(CUB_EXECUTABLE_OUTPUT_DIR "${CMAKE_BINARY_DIR}/bin")

cub_build_target_list()

if (CUB_ENABLE_HEADER_TESTING)
  include(cmake/CubHeaderTesting.cmake)
endif()

# Both testing and examples use ctest
if (CUB_ENABLE_TESTING OR CUB_ENABLE_EXAMPLES)
  include(CTest)
  enable_testing()
endif()

if (CUB_ENABLE_TESTING)
  add_subdirectory(test)
endif()

if (CUB_ENABLE_EXAMPLES)
  add_subdirectory(examples)
endif()

=== examples/CMakeLists.txt ===
# Create meta targets that build all examples for a single configuration:
foreach(cub_target IN LISTS CUB_TARGETS)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)
  set(config_meta_target ${config_prefix}.examples)
  add_custom_target(${config_meta_target})
  add_dependencies(${config_prefix}.all ${config_meta_target})
endforeach()

## cub_add_example
#
# Add an example executable and register it with ctest.
#
# target_name_var: Variable name to overwrite with the name of the example
#   target. Useful for post-processing target information per-backend.
# example_name: The name of the example minus "<config_prefix>.example." For
#   instance, examples/vector.cu will be "vector", and examples/cuda/copy.cu
#   would be "cuda.copy".
# example_src: The source file that implements the example.
# cub_target: The reference cub target with configuration information.
#
function(cub_add_example target_name_var example_name example_src cub_target)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)

  # The actual name of the test's target:
  set(example_target ${config_prefix}.example.${example_name})
  set(${target_name_var} ${example_target} PARENT_SCOPE)

  # Related target names:
  set(config_meta_target ${config_prefix}.examples)
  set(example_meta_target cub.all.example.${example_name})

  add_executable(${example_target} "${example_src}")
  target_link_libraries(${example_target} ${cub_target})
  cub_clone_target_properties(${example_target} ${cub_target})
  target_include_directories(${example_target} PRIVATE "${CUB_SOURCE_DIR}/examples")

  # Add to the active configuration's meta target
  add_dependencies(${config_meta_target} ${example_target})

  # Meta target that builds examples with this name for all configurations:
  if (NOT TARGET ${example_meta_target})
    add_custom_target(${example_meta_target})
  endif()
  add_dependencies(${example_meta_target} ${example_target})

  if (CUB_ENABLE_EXAMPLES_WITH_RDC)
    set_target_properties(${example_target} PROPERTIES
      CUDA_SEPARABLE_COMPILATION ON
    )
  endif()

  add_test(NAME ${example_target}
    COMMAND "$<TARGET_FILE:${example_target}>"
  )
endfunction()

add_subdirectory(cmake)
add_subdirectory(block)
add_subdirectory(device)

=== test/CMakeLists.txt ===
add_subdirectory(cmake)

# TODO investigate whether this is really needed:
math(EXPR CUB_TEST_ARCH "${CUB_MINIMAL_ENABLED_ARCH} * 10")
message(STATUS "CUB Test architecture (TEST_ARCH): ${CUB_TEST_ARCH}")

# Create meta targets that build all tests for a single configuration:
foreach(cub_target IN LISTS CUB_TARGETS)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)
  set(config_meta_target ${config_prefix}.tests)
  add_custom_target(${config_meta_target})
  add_dependencies(${config_prefix}.all ${config_meta_target})
endforeach()

file(GLOB test_srcs
  RELATIVE ${CUB_SOURCE_DIR}/test
  CONFIGURE_DEPENDS
  test_*.cu
)

## cub_add_test
#
# Add a test executable and register it with ctest.
#
# target_name_var: Variable name to overwrite with the name of the test
#   target. Useful for post-processing target information.
# test_name: The name of the test minus "<config_prefix>.test." For example,
#   testing/vector.cu will be "vector", and testing/cuda/copy.cu will be
#   "cuda.copy".
# test_src: The source file that implements the test.
# cub_target: The reference cub target with configuration information.
#
function(cub_add_test target_name_var test_name test_src cub_target)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)

  # The actual name of the test's target:
  set(test_target ${config_prefix}.test.${test_name})
  set(${target_name_var} ${test_target} PARENT_SCOPE)

  # Related target names:
  set(config_meta_target ${config_prefix}.tests)
  set(test_meta_target cub.all.test.${test_name})

  add_executable(${test_target} "${test_src}")
  target_link_libraries(${test_target} ${cub_target})
  cub_clone_target_properties(${test_target} ${cub_target})
  target_compile_definitions(${test_target} PRIVATE TEST_ARCH=${CUB_TEST_ARCH})
  target_include_directories(${test_target} PRIVATE "${CUB_SOURCE_DIR}/test")

  # Add to the active configuration's meta target
  add_dependencies(${config_meta_target} ${test_target})

  # Meta target that builds tests with this name for all configurations:
  if (NOT TARGET ${test_meta_target})
    add_custom_target(${test_meta_target})
  endif()
  add_dependencies(${test_meta_target} ${test_target})

  if (CUB_ENABLE_TESTS_WITH_RDC)
    set_target_properties(${test_target} PROPERTIES
      CUDA_SEPARABLE_COMPILATION ON
    )
  endif()

  add_test(NAME ${test_target}
    COMMAND "$<TARGET_FILE:${test_target}>"
  )
endfunction()

# Sets HAS_QUICK_VARIANT / HAS_QUICKER_VARIANT / NO_VARIANTS to True/False in
# the calling scope.
# Used to detect variants of unit tests depending on whether a source file
# contains the strings "QUICK_TEST" or "QUICKER_TEST".
function(cub_check_for_test_variants src)
  file(READ "${src}" data)

  string(FIND "${data}" "QUICK_TEST" quick_loc)
  set(HAS_QUICK_VARIANT False PARENT_SCOPE)
  if (NOT quick_loc EQUAL -1)
    set(HAS_QUICK_VARIANT True PARENT_SCOPE)
  endif()

  string(FIND "${data}" "QUICKER_TEST" quicker_loc)
  set(HAS_QUICKER_VARIANT False PARENT_SCOPE)
  if (NOT quicker_loc EQUAL -1)
    set(HAS_QUICKER_VARIANT True PARENT_SCOPE)
  endif()

  set(NO_VARIANTS False PARENT_SCOPE)
  if (NOT (HAS_QUICK_VARIANT OR HAS_QUICKER_VARIANT))
    set(NO_VARIANTS True PARENT_SCOPE)
  endif()
endfunction()

foreach (test_src IN LISTS test_srcs)
  # TODO: Per-test flags.

  get_filename_component(test_name "${test_src}" NAME_WE)
  string(REGEX REPLACE "^test_" "" test_name "${test_name}")

  # Some tests change behavior based on whether the compiler defs QUICK_TEST
  # and/or QUICKER_TEST are defined. Detect these and build variants for each
  # configuration:
  cub_check_for_test_variants("${test_src}")

  foreach(cub_target IN LISTS CUB_TARGETS)
    if (NO_VARIANTS)
      # Only one version of this test.
      cub_add_test(test_target ${test_name} "${test_src}" ${cub_target})
    else()
      # By default (no flags), the "thorough" version of the test is built:
      cub_add_test(test_target_thorough
        ${test_name}.thorough
        "${test_src}"
        ${cub_target}
      )

      # Add the other variants with appropriate suffixes:
      if (HAS_QUICK_VARIANT)
        cub_add_test(test_target_quick
          ${test_name}.quick
          "${test_src}"
          ${cub_target}
        )
        target_compile_definitions(${test_target_quick} PRIVATE QUICK_TEST)
      endif()

      if (HAS_QUICKER_VARIANT)
        cub_add_test(test_target_quicker
          ${test_name}.quicker
          "${test_src}"
          ${cub_target}
        )
        target_compile_definitions(${test_target_quicker} PRIVATE QUICKER_TEST)
      endif()
    endif()
  endforeach()
endforeach()

=== test/cmake/CMakeLists.txt ===
if (NOT CUB_IN_THRUST) # Thrust has its own checks for this:
  # Test that we can use `find_package` on an installed CUB:
  add_test(
    NAME cub.test.cmake.test_install
    COMMAND "${CMAKE_COMMAND}"
      --log-level=VERBOSE
      -G "${CMAKE_GENERATOR}"
      -S "${CMAKE_CURRENT_SOURCE_DIR}/test_install"
      -B "${CMAKE_CURRENT_BINARY_DIR}/test_install"
      -D "CUB_BINARY_DIR=${CUB_BINARY_DIR}"
      -D "CMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
      -D "CMAKE_CUDA_COMPILER=${CMAKE_CUDA_COMPILER}"
      -D "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
  )
endif()

## cub 1.9.10-1

=== debian/changelog ===
cub (1.9.10-1-1) unstable; urgency=medium

  * New upstream release 1.9.10-1 (CUDA 11.1).

 -- Andreas Beckmann <anbe@debian.org>  Mon, 10 Aug 2020 21:55:36 +0200

=== debian/control ===
Source: cub
Section: libdevel
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/thrust/cub
Vcs-Browser: https://salsa.debian.org/nvidia-team/cub
Vcs-Git: https://salsa.debian.org/nvidia-team/cub.git

Package: libcub-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: reusable software components for the CUDA programming model
 CUB provides state-of-the-art, reusable software components for every layer
 of the CUDA programming model:
 * Parallel primitives
   * Warp-wide "collective" primitives
   * Block-wide "collective" primitives
   * Device-wide primitives
 * Utilities
   * Fancy iterators
   * Thread and thread block I/O
   * PTX intrinsics
   * Device, kernel, and storage management

=== debian/watch ===
version=3

https://github.com/thrust/cub/releases .*/(\d+.*)\.tar\.gz

## cub 1.11.0

=== debian/changelog ===
cub (1.11.0-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Feb 2021 20:08:08 +0100

cub (1.11.0-1) unstable; urgency=medium

  * New upstream release 1.11.0.
  * New upstream release 1.10.0 (CUDA 11.2).
  * Update upstream location.
  * Bump Standards-Version to 4.5.1, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 08 Jan 2021 14:50:26 +0100

cub (1.9.10-1-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 23 Aug 2020 01:28:57 +0200

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
-Homepage: https://github.com/thrust/cub
+Standards-Version: 4.5.1
+Homepage: https://github.com/NVIDIA/cub
 Vcs-Browser: https://salsa.debian.org/nvidia-team/cub
 Vcs-Git: https://salsa.debian.org/nvidia-team/cub.git

## cub 1.14.0

=== test/cmake/CMakeLists.txt ===
--- 
+++ 
@@ -13,3 +13,12 @@
       -D "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
   )
 endif()
+
+# Check that namespace macros are used correctly:
+add_test(
+  NAME cub.test.cmake.check_namespace
+  COMMAND
+    "${CMAKE_COMMAND}"
+      -D "CUB_SOURCE_DIR=${CUB_SOURCE_DIR}"
+      -P "${CMAKE_CURRENT_LIST_DIR}/check_namespace.cmake"
+)

=== debian/changelog ===
cub (1.14.0-1) unstable; urgency=medium

  * New upstream release 1.14.0.
  * New upstream release 1.13.1 (CUDA 11.5).
  * New upstream release 1.13.0.
  * New upstream release 1.12.1 (CUDA 11.4).
  * New upstream release 1.12.0.
  * Bump Standards-Version to 4.6.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 26 Sep 2021 22:13:12 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/NVIDIA/cub
 Vcs-Browser: https://salsa.debian.org/nvidia-team/cub
 Vcs-Git: https://salsa.debian.org/nvidia-team/cub.git

=== debian/watch ===
version=4

https://github.com/NVIDIA/cub/releases .*/(\d+.*)\.tar\.gz

## cub 1.15.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
-# Will be increased to 3.18 when C++17 is enabled:
+# 3.15 is the minimum.
+# 3.17 for NVC++.
+# 3.18.3 for C++17 + CUDA.
 cmake_minimum_required(VERSION 3.15)
 
 # Remove this when we use the new CUDA_ARCHITECTURES properties.
@@ -7,7 +9,7 @@
 endif()
 
 # CXX is only needed for AppendOptionIfAvailable.
-project(CUB)
+project(CUB NONE)
 
 # Determine whether CUB is the top-level project or included into
 # another project via add_subdirectory().
@@ -48,7 +50,28 @@
 
 option(CUB_ENABLE_HEADER_TESTING "Test that all public headers compile." ON)
 option(CUB_ENABLE_TESTING "Build CUB testing suite." ON)
+option(CUB_ENABLE_THOROUGH_TESTING "Build CUB thorough test variants." ON)
+option(CUB_ENABLE_BENCHMARK_TESTING  "Build CUB benchmark test variants." ON)
+option(CUB_ENABLE_MINIMAL_TESTING "Build CUB minimal test variants." ON)
 option(CUB_ENABLE_EXAMPLES "Build CUB examples." ON)
+# This is needed for NVCXX QA, which requires a static set of executable names.
+# Only a single dialect may be enabled when this is off.
+option(CUB_ENABLE_CPP_DIALECT_IN_NAMES
+  "Include C++ dialect information in target/object/etc names."
+  ON
+)
+mark_as_advanced(CUB_ENABLE_CPP_DIALECT_IN_NAMES)
+
+# By default, suppress deprecation warnings when building our test suite,
+# since we'll need to test deprecated APIs with `-Werror`. This option is only
+# used when CUB is built stand-alone; otherwise the Thrust option has the same
+# effect.
+if (NOT CUB_IN_THRUST)
+  option(CUB_IGNORE_DEPRECATED_API
+    "Suppress warnings about deprecated Thrust/CUB API."
+    ON
+  )
+endif()
 
 # Check if we're actually building anything before continuing. If not, no need
 # to search for deps, etc. This is a common approach for packagers that just
@@ -63,6 +86,7 @@
 include(cmake/CubBuildCompilerTargets.cmake)
 include(cmake/CubBuildTargetList.cmake)
 include(cmake/CubCudaConfig.cmake)
+include(cmake/CubUtilities.cmake)
 
 if ("" STREQUAL "${CMAKE_BUILD_TYPE}")
   set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build." FORCE)

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -44,9 +44,7 @@
   add_dependencies(${example_meta_target} ${example_target})
 
   if (CUB_ENABLE_EXAMPLES_WITH_RDC)
-    set_target_properties(${example_target} PROPERTIES
-      CUDA_SEPARABLE_COMPILATION ON
-    )
+    cub_enable_rdc_for_cuda_target(${example_target})
   endif()
 
   add_test(NAME ${example_target}

=== test/CMakeLists.txt ===
# Create meta targets that build all tests for a single configuration:
foreach(cub_target IN LISTS CUB_TARGETS)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)
  set(config_meta_target ${config_prefix}.tests)
  add_custom_target(${config_meta_target})
  add_dependencies(${config_prefix}.all ${config_meta_target})
endforeach()

file(GLOB test_srcs
  RELATIVE ${CUB_SOURCE_DIR}/test
  CONFIGURE_DEPENDS
  test_*.cu
)

## cub_add_test
#
# Add a test executable and register it with ctest.
#
# target_name_var: Variable name to overwrite with the name of the test
#   target. Useful for post-processing target information.
# test_name: The name of the test minus "<config_prefix>.test." For example,
#   testing/vector.cu will be "vector", and testing/cuda/copy.cu will be
#   "cuda.copy".
# test_src: The source file that implements the test.
# cub_target: The reference cub target with configuration information.
#
function(cub_add_test target_name_var test_name test_src cub_target)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)

  # The actual name of the test's target:
  set(test_target ${config_prefix}.test.${test_name})
  set(${target_name_var} ${test_target} PARENT_SCOPE)

  # Related target names:
  set(config_meta_target ${config_prefix}.tests)
  set(test_meta_target cub.all.test.${test_name})

  add_executable(${test_target} "${test_src}")
  target_link_libraries(${test_target} ${cub_target})
  cub_clone_target_properties(${test_target} ${cub_target})
  target_include_directories(${test_target} PRIVATE "${CUB_SOURCE_DIR}/test")

  # Add to the active configuration's meta target
  add_dependencies(${config_meta_target} ${test_target})

  # Meta target that builds tests with this name for all configurations:
  if (NOT TARGET ${test_meta_target})
    add_custom_target(${test_meta_target})
  endif()
  add_dependencies(${test_meta_target} ${test_target})

  if (CUB_ENABLE_TESTS_WITH_RDC)
    cub_enable_rdc_for_cuda_target(${test_target})
  endif()

  add_test(NAME ${test_target}
    COMMAND "$<TARGET_FILE:${test_target}>"
  )
endfunction()

# Sets HAS_BENCHMARK_VARIANT / HAS_MINIMAL_VARIANT / NO_VARIANTS to True/False in
# the calling scope.
# Used to detect variants of unit tests depending on whether a source file
# contains the strings "CUB_TEST_BENCHMARK" or "CUB_TEST_MINIMAL".
function(cub_check_for_test_variants src)
  file(READ "${src}" data)

  string(FIND "${data}" "CUB_TEST_BENCHMARK" benchmark_loc)
  set(HAS_BENCHMARK_VARIANT False PARENT_SCOPE)
  if (NOT benchmark_loc EQUAL -1)
    set(HAS_BENCHMARK_VARIANT True PARENT_SCOPE)
  endif()

  string(FIND "${data}" "CUB_TEST_MINIMAL" minimal_loc)
  set(HAS_MINIMAL_VARIANT False PARENT_SCOPE)
  if (NOT minimal_loc EQUAL -1)
    set(HAS_MINIMAL_VARIANT True PARENT_SCOPE)
  endif()

  set(NO_VARIANTS False PARENT_SCOPE)
  if (NOT (HAS_BENCHMARK_VARIANT OR HAS_MINIMAL_VARIANT))
    set(NO_VARIANTS True PARENT_SCOPE)
  endif()
endfunction()

foreach (test_src IN LISTS test_srcs)
  # TODO: Per-test flags.

  get_filename_component(test_name "${test_src}" NAME_WE)
  string(REGEX REPLACE "^test_" "" test_name "${test_name}")

  # Some tests change behavior based on whether the compiler defs BENCHMARK
  # and/or MINIMAL_TEST are defined. Detect these and build variants for each
  # configuration:
  cub_check_for_test_variants("${test_src}")

  foreach(cub_target IN LISTS CUB_TARGETS)
    if (NO_VARIANTS)
      # Only one version of this test.
      cub_add_test(test_target ${test_name} "${test_src}" ${cub_target})
    else()
      # Multiple test variants requested, so we need to give the targets and
      # binaries suffixes.

      if (CUB_ENABLE_THOROUGH_TESTING)
        cub_add_test(test_target_thorough
          ${test_name}.thorough
          "${test_src}"
          ${cub_target}
        )
        target_compile_definitions(${test_target_thorough} PRIVATE CUB_TEST_THOROUGH)
      endif()

      if (CUB_ENABLE_BENCHMARK_TESTING)
        if (HAS_BENCHMARK_VARIANT)
          cub_add_test(test_target_benchmark
            ${test_name}.benchmark
            "${test_src}"
            ${cub_target}
          )
          target_compile_definitions(${test_target_benchmark} PRIVATE CUB_TEST_BENCHMARK)
        endif()
      endif()

      if (CUB_ENABLE_MINIMAL_TESTING)
        if (HAS_MINIMAL_VARIANT)
          cub_add_test(test_target_minimal
            ${test_name}.minimal
            "${test_src}"
            ${cub_target}
          )
          target_compile_definitions(${test_target_minimal} PRIVATE CUB_TEST_MINIMAL)
        endif()
      endif()
    endif()
  endforeach()
endforeach()

add_subdirectory(cmake)

=== debian/changelog ===
cub (1.15.0-3) unstable; urgency=medium

  * Tune autopkgtests.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 12 Mar 2022 02:23:11 +0100

cub (1.15.0-2) unstable; urgency=medium

  * Use upstream build system for installation.
  * Add superficial autopkgtest for cmake find_package(CUB).
  * Add superficial autopkgtest compiling the upstream testsuite for C++14
    and C++17 (requires nvidia-cuda-toolkit/non-free).
    (Running the testsuite would require a CUDA capable CPU and using the
    kernel module from nvidia-graphics-drivers/non-free.)
    Currently this only works with g++-10 while g++-11 fails with spurious
    errors.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 23 Feb 2022 10:54:36 +0100

cub (1.15.0-1) unstable; urgency=medium

  * New upstream release 1.15.0 (CUDA 11.6).

 -- Andreas Beckmann <anbe@debian.org>  Thu, 10 Feb 2022 17:03:21 +0100

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  Andreas Beckmann <anbe@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
+ cmake,
 Rules-Requires-Root: no
 Standards-Version: 4.6.0
 Homepage: https://github.com/NVIDIA/cub
@@ -16,6 +17,8 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
+Breaks:
+ libthrust-dev (<< 1.15.0),
 Description: reusable software components for the CUDA programming model
  CUB provides state-of-the-art, reusable software components for every layer
  of the CUDA programming model:

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --without single-binary

# the cmake build system for examples and tests assumes CUDA availability
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCUB_ENABLE_HEADER_TESTING=OFF \
		-DCUB_ENABLE_TESTING=OFF \
		-DCUB_ENABLE_EXAMPLES=OFF \

# for debhelper-compat (<< 15)
override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

execute_after_dh_auto_install:
	# remove empty directories
	find debian/tmp -depth -type d -exec sh -c 'd="{}"; rmdir --ignore-fail-on-non-empty "$$d" ; test -d "$$d" || echo "removed $$d"' \;

override_dh_installexamples:
	dh_installexamples -X.gitignore

=== debian/tests/control ===
Test-Command: cmake -Wno-dev -S debian/tests/cmake -B $AUTOPKGTEST_TMP
Features: test-name=cmake_find_package_CUB
Depends:
 @,
 cmake,
 g++,
Restrictions:
 superficial,

Test-Command: debian/tests/compile-cub-tests cuda-g++ 14
Features: test-name=compile_testsuite_cuda-g++_C++14
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 make,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 flaky,

Test-Command: debian/tests/compile-cub-tests cuda-g++ 17
Features: test-name=compile_testsuite_cuda-g++_C++17
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 make,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 flaky,

Test-Command: debian/tests/compile-cub-tests g++-11 14
Features: test-name=compile_testsuite_g++-11_C++14
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 g++-11,
 make,
 nvidia-cuda-toolkit,
Restrictions:
 superficial,
 flaky,

Test-Command: debian/tests/compile-cub-tests g++-11 17
Features: test-name=compile_testsuite_g++-11_C++17
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 g++-11,
 make,
 nvidia-cuda-toolkit,
Restrictions:
 superficial,
 flaky,

Test-Command: debian/tests/compile-cub-tests g++-10 14
Features: test-name=compile_testsuite_g++-10_C++14
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 g++-10,
 make,
 nvidia-cuda-toolkit,
Restrictions:
 superficial,
 flaky,

Test-Command: debian/tests/compile-cub-tests g++-10 17
Features: test-name=compile_testsuite_g++-10_C++17
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 g++-10,
 make,
 nvidia-cuda-toolkit,
Restrictions:
 superficial,
 flaky,

## cub 1.16.0

=== debian/changelog ===
cub (1.16.0-2) unstable; urgency=medium

  * Update watch file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 11 Nov 2022 12:05:01 +0100

cub (1.16.0-1) unstable; urgency=medium

  * New upstream release 1.16.0.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 18 Jun 2022 15:14:27 +0200

cub (1.15.0-4) unstable; urgency=medium

  * Generate debian/tests/control from debian/tests/control.sh.
  * Reduce amount of autopkgtest tests.
  * Add salsa-ci.yml.
  * Bump Standards-Version to 4.6.1, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 03 Jun 2022 15:29:58 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  debhelper-compat (= 13),
  cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/NVIDIA/cub
 Vcs-Browser: https://salsa.debian.org/nvidia-team/cub
 Vcs-Git: https://salsa.debian.org/nvidia-team/cub.git

=== debian/rules ===
--- 
+++ 
@@ -15,8 +15,15 @@
 	dh_auto_install --destdir=debian/tmp
 
 execute_after_dh_auto_install:
+	$(RM) -v debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/cub/cub-header-search.cmake.in
 	# remove empty directories
 	find debian/tmp -depth -type d -exec sh -c 'd="{}"; rmdir --ignore-fail-on-non-empty "$$d" ; test -d "$$d" || echo "removed $$d"' \;
 
 override_dh_installexamples:
 	dh_installexamples -X.gitignore
+
+
+debian/tests/control: debian/tests/control.sh
+	sh $< > $@
+
+clean: debian/tests/control

=== debian/watch ===
version=4

opts="uversionmangle=s/-rc/~rc/, filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/NVIDIA/cub/tags \
  (?:.*?/)?v?(\d[\d.]*(?:-.*)?)\.tar\.gz debian uupdate

## cub 1.17.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,9 +50,6 @@
 
 option(CUB_ENABLE_HEADER_TESTING "Test that all public headers compile." ON)
 option(CUB_ENABLE_TESTING "Build CUB testing suite." ON)
-option(CUB_ENABLE_THOROUGH_TESTING "Build CUB thorough test variants." ON)
-option(CUB_ENABLE_BENCHMARK_TESTING  "Build CUB benchmark test variants." ON)
-option(CUB_ENABLE_MINIMAL_TESTING "Build CUB minimal test variants." ON)
 option(CUB_ENABLE_EXAMPLES "Build CUB examples." ON)
 # This is needed for NVCXX QA, which requires a static set of executable names.
 # Only a single dialect may be enabled when this is off.
@@ -62,14 +59,12 @@
 )
 mark_as_advanced(CUB_ENABLE_CPP_DIALECT_IN_NAMES)
 
-# By default, suppress deprecation warnings when building our test suite,
-# since we'll need to test deprecated APIs with `-Werror`. This option is only
-# used when CUB is built stand-alone; otherwise the Thrust option has the same
-# effect.
+# This option is only used when CUB is built stand-alone; otherwise the Thrust
+# option has the same effect.
 if (NOT CUB_IN_THRUST)
   option(CUB_IGNORE_DEPRECATED_API
     "Suppress warnings about deprecated Thrust/CUB API."
-    ON
+    OFF
   )
 endif()

=== test/CMakeLists.txt ===
# The function below reads the filepath `src`, extracts the %PARAM% comments,
# and fills `labels_var` with a list of `label1_value1.label2_value2...`
# strings, and puts the corresponding `DEFINITION=value1:DEFINITION=value2`
# entries into `defs_var`.
#
# See the README.md file in this directory for background info.
function(cub_get_test_params src labels_var defs_var)
  file(READ "${src}" file_data)
  set(param_regex "//[ ]+%PARAM%[ ]+([^ ]+)[ ]+([^ ]+)[ ]+([^\n]*)")

  string(REGEX MATCHALL
    "${param_regex}"
    matches
    "${file_data}"
  )

  set(variant_labels)
  set(variant_defs)

  foreach(match IN LISTS matches)
    string(REGEX MATCH
      "${param_regex}"
      unused
      "${match}"
    )
    set(def ${CMAKE_MATCH_1})
    set(label ${CMAKE_MATCH_2})
    set(values "${CMAKE_MATCH_3}")
    string(REPLACE ":" ";" values "${values}")

    # Build lists of test name suffixes (labels) and preprocessor definitions
    # (defs) containing the cartesian product of all param values:
    if (NOT variant_labels)
      foreach(value IN LISTS values)
        list(APPEND variant_labels ${label}_${value})
      endforeach()
    else()
      set(tmp_labels)
      foreach(old_label IN LISTS variant_labels)
        foreach(value IN LISTS values)
          list(APPEND tmp_labels ${old_label}.${label}_${value})
        endforeach()
      endforeach()
      set(variant_labels "${tmp_labels}")
    endif()

    if (NOT variant_defs)
      foreach(value IN LISTS values)
        list(APPEND variant_defs ${def}=${value})
      endforeach()
    else()
      set(tmp_defs)
      foreach(old_def IN LISTS variant_defs)
        foreach(value IN LISTS values)
          list(APPEND tmp_defs ${old_def}:${def}=${value})
        endforeach()
      endforeach()
      set(variant_defs "${tmp_defs}")
    endif()

  endforeach()

  set(${labels_var} "${variant_labels}" PARENT_SCOPE)
  set(${defs_var} "${variant_defs}" PARENT_SCOPE)
endfunction()

# Create meta targets that build all tests for a single configuration:
foreach(cub_target IN LISTS CUB_TARGETS)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)
  set(config_meta_target ${config_prefix}.tests)
  add_custom_target(${config_meta_target})
  add_dependencies(${config_prefix}.all ${config_meta_target})
endforeach()

file(GLOB test_srcs
  RELATIVE ${CUB_SOURCE_DIR}/test
  CONFIGURE_DEPENDS
  test_*.cu
)

## cub_add_test
#
# Add a test executable and register it with ctest.
#
# target_name_var: Variable name to overwrite with the name of the test
#   target. Useful for post-processing target information.
# test_name: The name of the test minus "<config_prefix>.test." For example,
#   testing/vector.cu will be "vector", and testing/cuda/copy.cu will be
#   "cuda.copy".
# test_src: The source file that implements the test.
# cub_target: The reference cub target with configuration information.
#
function(cub_add_test target_name_var test_name test_src cub_target)
  cub_get_target_property(config_prefix ${cub_target} PREFIX)

  # The actual name of the test's target:
  set(test_target ${config_prefix}.test.${test_name})
  set(${target_name_var} ${test_target} PARENT_SCOPE)

  # Related target names:
  set(config_meta_target ${config_prefix}.tests)
  set(test_meta_target cub.all.test.${test_name})

  add_executable(${test_target} "${test_src}")
  target_link_libraries(${test_target} ${cub_target})
  cub_clone_target_properties(${test_target} ${cub_target})
  target_include_directories(${test_target} PRIVATE "${CUB_SOURCE_DIR}/test")

  # Add to the active configuration's meta target
  add_dependencies(${config_meta_target} ${test_target})

  # Meta target that builds tests with this name for all configurations:
  if (NOT TARGET ${test_meta_target})
    add_custom_target(${test_meta_target})
  endif()
  add_dependencies(${test_meta_target} ${test_target})

  if (CUB_ENABLE_TESTS_WITH_RDC)
    cub_enable_rdc_for_cuda_target(${test_target})
  endif()

  add_test(NAME ${test_target}
    COMMAND "$<TARGET_FILE:${test_target}>"
  )
endfunction()

foreach (test_src IN LISTS test_srcs)
  get_filename_component(test_name "${test_src}" NAME_WE)
  string(REGEX REPLACE "^test_" "" test_name "${test_name}")

  cub_get_test_params("${test_src}" variant_labels variant_defs)
  list(LENGTH variant_labels num_variants)

  # Subtract 1 to support the inclusive endpoint of foreach(...RANGE...):
  math(EXPR range_end "${num_variants} - 1")

  # Verbose output:
  if (NOT num_variants EQUAL 0)
    message(VERBOSE "Detected ${num_variants} variants of test '${test_src}':")
    foreach(var_idx RANGE ${range_end})
      math(EXPR i "${var_idx} + 1")
      list(GET variant_labels ${var_idx} label)
      list(GET variant_defs ${var_idx} defs)
      message(VERBOSE "  ${i}: ${test_name} ${label} ${defs}")
    endforeach()
  endif()

  foreach(cub_target IN LISTS CUB_TARGETS)
    cub_get_target_property(config_prefix ${cub_target} PREFIX)

    if (num_variants EQUAL 0)
      # Only one version of this test.
      cub_add_test(test_target ${test_name} "${test_src}" ${cub_target})
    else()
      # Meta target to build all parametrizations of the current test for the
      # current CUB_TARGET config
      set(variant_meta_target ${config_prefix}.test.${test_name}.all)
      add_custom_target(${variant_meta_target})

      # Meta target to build all parametrizations of the current test for all
      # CUB_TARGET configs
      set(cub_variant_meta_target cub.all.test.${test_name}.all)
      if (NOT TARGET ${cub_variant_meta_target})
        add_custom_target(${cub_variant_meta_target})
      endif()

      # Generate multiple tests, one per variant.
      # See `cub_get_test_params` for details.
      foreach(var_idx RANGE ${range_end})
        list(GET variant_labels ${var_idx} label)
        list(GET variant_defs ${var_idx} defs)
        string(REPLACE ":" ";" defs "${defs}")

        cub_add_test(test_target
          ${test_name}.${label}
          "${test_src}"
          ${cub_target}
        )
        add_dependencies(${variant_meta_target} ${test_target})
        add_dependencies(${cub_variant_meta_target} ${test_target})
        target_compile_definitions(${test_target} PRIVATE ${defs})
      endforeach()
    endif()
  endforeach()
endforeach()

add_subdirectory(cmake)

=== debian/changelog ===
cub (1.17.2-2) unstable; urgency=medium

  * Stop testing with g++-10.
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 21 Feb 2023 10:51:10 +0100

cub (1.17.2-1) unstable; urgency=medium

  * New upstream release 1.17.2.
  * Install *.cmake to CMAKE_INSTALL_DATADIR.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 23 Dec 2022 20:55:22 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  debhelper-compat (= 13),
  cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/NVIDIA/cub
 Vcs-Browser: https://salsa.debian.org/nvidia-team/cub
 Vcs-Git: https://salsa.debian.org/nvidia-team/cub.git

=== debian/tests/control ===
Test-Command: cmake -Wno-dev -S debian/tests/cmake -B $AUTOPKGTEST_TMP
Features: test-name=cmake_find_package_CUB
Depends:
 @,
 cmake,
 g++,
Restrictions:
 superficial,

Test-Command: debian/tests/compile-cub-tests cuda-g++ 17
Features: test-name=compile_testsuite_cuda-g++_C++17
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 make,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 flaky,

Test-Command: debian/tests/compile-cub-tests cuda-g++ 14
Features: test-name=compile_testsuite_cuda-g++_C++14
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 make,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 flaky,

Test-Command: debian/tests/compile-cub-tests g++-11 17
Features: test-name=compile_testsuite_g++-11_C++17
Architecture: amd64 arm64 ppc64el
Depends:
 @,
 cmake,
 make,
 g++-11,
 nvidia-cuda-toolkit-gcc,
Restrictions:
 superficial,
 flaky,
 skippable,

=== debian/watch ===
version=4

opts="uversionmangle=s/-rc/~rc/, filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/NVIDIA/cub/tags \
  (?:.*?/)?v?(\d[\d.]*(?:-.*)?)\.tar\.gz

## cub 2.0.1

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,14 @@
   add_custom_target(${config_meta_target})
   add_dependencies(${config_prefix}.all ${config_meta_target})
 endforeach()
+
+# Update flags to reflect RDC options. See note in CubCudaConfig.cmake --
+# these flag variables behave unintuitively:
+if (CUB_ENABLE_EXAMPLES_WITH_RDC)
+  set(CMAKE_CUDA_FLAGS "${CUB_CUDA_FLAGS_BASE} ${CUB_CUDA_FLAGS_RDC}")
+else()
+  set(CMAKE_CUDA_FLAGS "${CUB_CUDA_FLAGS_BASE} ${CUB_CUDA_FLAGS_NO_RDC}")
+endif()
 
 ## cub_add_example
 #

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,11 @@
+# Some tests always build with RDC, so make sure that the sm_XX flags are
+# compatible. See note in CubCudaConfig.cmake.
+# TODO once we're using CUDA_ARCHITECTURES, we can setup non-rdc fallback
+# tests to build for non-rdc arches. But for now, all files in a given directory
+# must build with the same `CMAKE_CUDA_FLAGS` due to CMake constraints around
+# how CUDA_FLAGS works.
+set(CMAKE_CUDA_FLAGS "${CUB_CUDA_FLAGS_BASE} ${CUB_CUDA_FLAGS_RDC}")
+
 # The function below reads the filepath `src`, extracts the %PARAM% comments,
 # and fills `labels_var` with a list of `label1_value1.label2_value2...`
 # strings, and puts the corresponding `DEFINITION=value1:DEFINITION=value2`
@@ -23,6 +31,7 @@
       unused
       "${match}"
     )
+
     set(def ${CMAKE_MATCH_1})
     set(label ${CMAKE_MATCH_2})
     set(values "${CMAKE_MATCH_3}")
@@ -57,7 +66,6 @@
       endforeach()
       set(variant_defs "${tmp_defs}")
     endif()
-
   endforeach()
 
   set(${labels_var} "${variant_labels}" PARENT_SCOPE)
@@ -105,6 +113,7 @@
   target_link_libraries(${test_target} ${cub_target})
   cub_clone_target_properties(${test_target} ${cub_target})
   target_include_directories(${test_target} PRIVATE "${CUB_SOURCE_DIR}/test")
+  target_compile_definitions(${test_target} PRIVATE CUB_DEBUG_HOST_ASSERTIONS)
 
   # Add to the active configuration's meta target
   add_dependencies(${config_meta_target} ${test_target})
@@ -115,15 +124,33 @@
   endif()
   add_dependencies(${test_meta_target} ${test_target})
 
-  if (CUB_ENABLE_TESTS_WITH_RDC)
-    cub_enable_rdc_for_cuda_target(${test_target})
-  endif()
-
   add_test(NAME ${test_target}
     COMMAND "$<TARGET_FILE:${test_target}>"
   )
 endfunction()
 
+# Sets out_var to 1 if the label contains cdp variants, regardless of whether
+# or not CDP is enabled in this particular variant.
+function(_cub_has_cdp_variant out_var label)
+  string(FIND "${label}" "cdp_" idx)
+  if (idx EQUAL -1)
+    set(${out_var} 0 PARENT_SCOPE)
+  else()
+    set(${out_var} 1 PARENT_SCOPE)
+  endif()
+endfunction()
+
+# Sets out_var to 1 if the label contains "cdp_1", e.g. cdp is explicitly
+# requested for this variant.
+function(_cub_is_cdp_enabled_variant out_var label)
+  string(FIND "${label}" "cdp_1" idx)
+  if (idx EQUAL -1)
+    set(${out_var} 0 PARENT_SCOPE)
+  else()
+    set(${out_var} 1 PARENT_SCOPE)
+  endif()
+endfunction()
+
 foreach (test_src IN LISTS test_srcs)
   get_filename_component(test_name "${test_src}" NAME_WE)
   string(REGEX REPLACE "^test_" "" test_name "${test_name}")
@@ -135,7 +162,7 @@
   math(EXPR range_end "${num_variants} - 1")
 
   # Verbose output:
-  if (NOT num_variants EQUAL 0)
+  if (num_variants GREATER 0)
     message(VERBOSE "Detected ${num_variants} variants of test '${test_src}':")
     foreach(var_idx RANGE ${range_end})
       math(EXPR i "${var_idx} + 1")
@@ -151,11 +178,16 @@
     if (num_variants EQUAL 0)
       # Only one version of this test.
       cub_add_test(test_target ${test_name} "${test_src}" ${cub_target})
-    else()
+      if (CUB_ENABLE_TESTS_WITH_RDC)
+        cub_enable_rdc_for_cuda_target(${test_target})
+      endif()
+    else() # has variants:
       # Meta target to build all parametrizations of the current test for the
       # current CUB_TARGET config
       set(variant_meta_target ${config_prefix}.test.${test_name}.all)
-      add_custom_target(${variant_meta_target})
+      if (NOT TARGET ${variant_meta_target})
+        add_custom_target(${variant_meta_target})
+      endif()
 
       # Meta target to build all parametrizations of the current test for all
       # CUB_TARGET configs
@@ -170,6 +202,10 @@
         list(GET variant_labels ${var_idx} label)
         list(GET variant_defs ${var_idx} defs)
         string(REPLACE ":" ";" defs "${defs}")
+
+        # Check if the test has explicit CDP variants:
+        _cub_has_cdp_variant(explicit_cdp "${label}")
+        _cub_is_cdp_enabled_variant(enable_cdp "${label}")
 
         cub_add_test(test_target
           ${test_name}.${label}
@@ -179,9 +215,20 @@
         add_dependencies(${variant_meta_target} ${test_target})
         add_dependencies(${cub_variant_meta_target} ${test_target})
         target_compile_definitions(${test_target} PRIVATE ${defs})
-      endforeach()
-    endif()
-  endforeach()
-endforeach()
+
+        # Enable RDC if the test either:
+        # 1. Explicitly requests it (cdp_1 label)
+        # 2. Does not have an explicit CDP variant (no cdp_0 or cdp_1) but
+        #    RDC testing is globally enabled.
+        #
+        # Tests that explicitly request no cdp (cdp_0 label) should never enable
+        # RDC.
+        if (enable_cdp OR ((NOT explicit_cdp) AND CUB_ENABLE_TESTS_WITH_RDC))
+          cub_enable_rdc_for_cuda_target(${test_target})
+        endif()
+      endforeach() # Variant
+    endif() # Has variants
+  endforeach() # CUB targets
+endforeach() # Source file
 
 add_subdirectory(cmake)

=== examples/cmake/add_subdir/CMakeLists.txt ===
# This example demonstrates / tests adding CUB via a CMake add_subdirectory
# call from a parent project.

cmake_minimum_required(VERSION 3.15)

# Silence warnings about empty CUDA_ARCHITECTURES properties on example targets:
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.18)
  cmake_policy(SET CMP0104 OLD)
endif()

project(CubAddSubDirExample CUDA)

# Use your project's checkout of CUB here, for most cases
# `add_subdirectory(cub)` will be sufficient.
add_subdirectory("${CUB_ROOT}" cub)

# Link the CUB::CUB target to your project's targets
add_executable(HelloCUB dummy.cu)
target_link_libraries(HelloCUB CUB::CUB)

#
# Validation
#

function(assert_target target_name)
  if (NOT TARGET "${target_name}")
    message(FATAL_ERROR "Target '${target_name}' not defined.")
  endif()
endfunction()

assert_target(CUB::CUB)
assert_target(HelloCUB)

=== debian/changelog ===
cub (2.0.1-2) unstable; urgency=medium

  * Add Depends: libcu++-dev (>= 1.8.0).
  * Fix autopkgtests with older nvcc.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 15 Jun 2023 09:50:17 +0200

cub (2.0.1-1) experimental; urgency=medium

  * New upstream release 2.0.1.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 22 Feb 2023 11:17:46 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,9 @@
 Package: libcub-dev
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends:
+ libcu++-dev (>= 1.8.0),
+ ${misc:Depends}
 Breaks:
  libthrust-dev (<< 1.15.0),
 Description: reusable software components for the CUDA programming model

=== debian/tests/control ===
--- 
+++ 
@@ -17,6 +17,7 @@
  nvidia-cuda-toolkit-gcc,
 Restrictions:
  superficial,
+ allow-stderr,
  flaky,
 
 Test-Command: debian/tests/compile-cub-tests cuda-g++ 14
@@ -29,6 +30,7 @@
  nvidia-cuda-toolkit-gcc,
 Restrictions:
  superficial,
+ allow-stderr,
  flaky,
 
 Test-Command: debian/tests/compile-cub-tests g++-11 17
@@ -42,6 +44,7 @@
  nvidia-cuda-toolkit-gcc,
 Restrictions:
  superficial,
+ allow-stderr,
  flaky,
  skippable,

## cub 2.1.0

=== debian/changelog ===
cub (2.1.0-1) unstable; urgency=medium

  * New upstream release 2.1.0.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 25 Jun 2024 18:32:02 +0200
